var Config = {};

//base:
Config.debug = false;
Config.framerate = 30;
Config.framerateMobile = 30;

//piece:
Config.lightVector = vec3.fromValues(1.2,-1,-2);
Config.focalLength = 500;//perspective factor
Config.shadowStrength = .3;//opacity of shadow on buildings. Higher is more black.
Config.groundShadowColor = "#999999";
Config.groundColor = "#FFFFFF";//"#999999". When same as groundShadowColor, ground shadows can and will be skipped.
Config.groundColorOutlineMode = "#000000";

Config.showGrid = false;
Config.toggleModeAction = "click";//"down" (at mousedown) / "up" (at mouseup) / "still" (after braking) / "click" (without drag)

Config.mobileScaleFactor = 4;//set to 1 for same scaling as on non-mobile

Config.colorChangeOn = false;//true/false
Config.colorChangeIntervalMin = 8000;//in msecs
Config.colorChangeIntervalMax = 9000;//in msecs

Config.brakeFactor = .8;//Set to 0 for instant standstill. Closer to 1 is less braking.
Config.autoMoveSpeed = 2.5;//in relation to viewport dimensions. Set to 0 for no auto move.
Config.autoMoveDirection = "last";//direction at start and after click without drag. "none" / "random" / "last" (last known angle else random) / 0-360 (fixed angle)

//parameters for blocks
Config.tileSizeFactor = .2;
Config.tileDefs = [
	[0,0,.5,.625,0,.62,.5,.375,.5,0,.44,.57,.5,.575,.705,.425,.94,0,.395,.3,.94,.3,.265,.274,1,1.115,.6,.425,1,1.54,.395,.46,1.205,.35,.395,.435,1.205,.785,.395,.33,1.335,0,.35,.35,1.395,1.54,.575,.46,1.6,.401,.394,.771,1.6,1.17,.369,.37,1.683,.005,.31,.395,1.969,1.43,.44,.57,1.994,1,.65,.43,2.41,1.515,.589,.485,2.644,1,.355,.514],
	[0,.005,.5,.375,0,.375,.5,.625,.5,0,.38,.645,.5,.65,.705,.35,.88,.35,.325,.295,.94,0,.395,.35,1,1.115,.6,.425,1,1.54,.575,.46,1.205,.35,.395,.33,1.205,.68,.395,.435,1.335,0,.35,.35,1.57,1.54,.395,.46,1.6,.77,.364,.771,1.601,.4,.4,.365,1.683,.005,.31,.395,1.969,1.43,.44,.57,1.994,1,.65,.43,2.41,1.515,.589,.485,2.644,1,.355,.514]
]

Config.marginMin = .005;//in relation to viewport dimensions
Config.marginMax = .02;//in relation to viewport dimensions
Config.heightMin = .5;//relative to total screen area
Config.heightMax = 3;//relative to total screen area
Config.heightExtremeFactor = 1.6;// >=1, greater is more extreme heights (lows&highs)

Config.colors = ["#FF0000","#00FFFF","#335BEB","#00D100","#FF6EFF","#FFE500","#53FBA2","#48CEFF","#FFD0FF"];