(function(window) {
var Interaction = function(target)
{
	this.initialize(target);
}
var p = Interaction.prototype;

p.initialize = function(target)
{
	this.target = target;
	this.stage = target.stage;
	this.canvas = target.canvas;
	//Enable multitouch. NB: touchEvents received as mouseEvents! onTouchStart etc not called!
	createjs.Touch.enable(this.stage);
	var that = this;
	this.stage.addEventListener("mousedown", function(e) { that.onMouseDown(e); });
	this.stage.addEventListener("pressmove", function(e) { that.onMouseMove(e); });
	this.stage.addEventListener("pressup", function(e) { that.onMouseUp(e); });
	this.canvas.addEventListener('mousewheel', function(e){ that.onMouseWheel(e); return false;}, false);//GC,IE
	this.canvas.addEventListener('DOMMouseScroll', function(e){ that.onMouseWheel(e); return false;}, false);//FF
	this.touchIds = [];
	this.moveLast = 0;
}
p.onMouseWheel = function(e)
{ 
	//var step = Math.abs(e.detail ? e.detail/3 : e.wheelDelta/120);
	this.target.toggleMode();
}
p.onMouseDown = function(e)
{
	//log("onMouseDown",e.pointerID,e.primary);
	var id = e.pointerID;
	if (id>-1)
	{
		this.touchIds.push(id);
		log(this.touchIds);
	}
	this.target.startDrag(this.stage.mouseX,this.stage.mouseY);
}
p.onMouseMove = function(e)
{
	if (this.touchIds.length>1)
	{
		//multitouch: toggleMode
		var now = Date.now();
		if (now-this.moveLast>25)
		{
			this.target.toggleMode();
			this.moveLast = now;
		}
	}
	else
	{
		//single Touch: drag
		this.target.updateDrag(this.stage.mouseX,this.stage.mouseY);
	}
}
p.onMouseUp = function(e)
{
	var id = e.pointerID;
	if (id>-1)
	{
		var idx = this.touchIds.indexOf(id);
		this.touchIds.splice(idx,1);
		//log("onMouseUp",id, idx,e.primary, this.touchIds);
	}
	this.target.stopDrag();
}

window.Interaction = Interaction;
}(window));